<template>
  <div
    v-if="isAdmin!=null"
    class="container-fluid"
  >
    <h1><users-icon />Modifier un gestionnaire</h1>
    <hr>
    <div
      class="row"
    >
      <div
        class="col-md-12"
        style="margin-bottom: 1vh;"
      >
        <input
          class="btn btn-primary"
          type="button"
          value="Retour"
          @click="$router.push({'path':'/admin/accueil?tab=1'})"
        >
      </div>
      <form
        id="managerForm"
        novalidate="novalidate"
      >
        <div class="row">
          <div class="col-xs-12 col-md-6">
            <div class="form-group required">
              <label
                for="email"
              >Email&nbsp;:</label>
              <input
                id="email"
                v-model="manager.email"
                name="email"
                type="email"
                class="form-control"
                required="required"
              >
            </div>
          </div>
          <div
            class="row"
            style="margin-top: 1em;"
          >
            <div
              class="col-xs-12"
              style="display: flex; flex-direction: column;"
            >
              <label style="text-align: center;">Equipes(s)</label>
              <el-transfer
                v-model="selectedTeams"
                style="margin: auto; width: 100%;"
                :data="availableTeams"
                :titles="['Disponible(s)', 'Autorisée(s)']"
                :props="{
                  key: 'id',
                  label: 'description'
                }"
                filterable
                :filter-method="filterMethod"
                filter-placeholder="Rechercher"
              />
            </div>
          </div>
          <br>
        </div>
        <div class="row">
          <div
            class="form-group btn-list"
          >
            <input
              class="btn btn-primary"
              :disabled="submitDisabled"
              type="submit"
              value="Mettre à jour le gestionnaire"
              @click="performUpdateManager()"
            >
          </div>
        </div>
      </form>
    </div>
  </div>
  <div
    v-else
  >
    Vous n'avez pas la permission requise pour afficher ces informations.
  </div>
</template>

<script>
import UsersIcon from "../../../components/Icon/UsersIcon";
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";
export default {
  name: "AdminEditManager",
  components: {UsersIcon},
  data() {
    return {
      selectedTeams: [],
      availableTeams: [],
      validator: null,
    }
  },
  computed: {
    ...mapGetters([
      'isAdmin',
      'isLoading',
      'teams',
      'manager',
    ]),
    submitDisabled: function() {
      return this.isLoading || this.manager.email.length === 0;
    },
  },
  created() {
    this.fetchManager(this.$route.params.id)
      .then((manager)=>{
        manager.teams.forEach(team => {
          this.selectedTeams.push(team.id)
        })
      })
    this.fetchTeams().then(()=>{
      this.teams.forEach(team => {
        this.availableTeams.push(team)
      })
    })
  },
  mounted() {
    this.validator = $('#managerForm').submit(function (e) {
      e.preventDefault();
    }).validate({
      rules: {
        email: {
          required: true,
          email: true
        }
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass('help-block');

        if (element.prop("type") === 'checkbox') {
          error.insertAfter(element.parent('label'));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchTeams',
      'updateManager',
      'loadingStarts',
      'loadingEnds',
      'fetchManager',
      'removeManager',
      'addManager',
      'fetchManagers'
    ]),
    async removeTeamManagers(manager) {
      for(const team of manager.teams) {
        if(!this.selectedTeams.find((selectedTeam) => {
          return team.id === selectedTeam
        })) {
          await this.removeManager({
            teamId: team.id,
            managerId: manager.id
          })
        }
      }
    },
    async addTeamManagers(manager) {
      for(const selectedTeam of this.selectedTeams) {
        if(!manager.teams.find((team) => {
          return team.id === selectedTeam
        })) {
          await this.addManager({
            teamId: selectedTeam,
            managerId: manager.id
          })
        }
      }
    },
    performUpdateManager() {
      if ($("#managerForm").valid()) {
        this.loadingStarts()
        this.updateManager(this.manager).then((manager)=> {
          this.removeTeamManagers(manager).then(() => {
            this.addTeamManagers(manager).then(()=>{
              this.fetchManagers()
            }).then(()=>{
              VanillaToasts.create({
                title: 'Edition gestionnaire',
                text: 'Gestionnaire mis à jour succès.',
                type: 'success',
                timeout: 10000,
              });
              this.loadingEnds()
              this.$router.push({ path: '/admin/accueil?tab=1'})
            })
          })
        })
      }
    },
    filterMethod(query, item) {
      return item.description.toLowerCase().indexOf(query.toLowerCase()) > -1;
    }
  }
}
</script>

<style scoped>

</style>